// Problem ROUTES, setter's 100-point solution

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cassert>
using namespace std;

#define maxn 1000000

int n,m,i,j,pr_cc[maxn],pr_bcc[maxn],size_cc[maxn],size_bcc[maxn],pr[maxn],x,y,a,b,cc_a,cc_b,k,rt,chi,p,cu,u[maxn],ca[maxn],cb[maxn],lca;
long long SumCC,SumBCC;

int GetBCC(int k){ // get an information to which BCC does the vertice k belong
	if(k!=pr_bcc[k])pr_bcc[k]=GetBCC(pr_bcc[k]);
	return pr_bcc[k];
}

int GetCC(int k){ // get an information to which connected component the vertice k belong
	if(k!=pr_cc[k])pr_cc[k]=GetCC(pr_cc[k]);
	return pr_cc[k];
}

int main (int argc, char * const argv[]) {
	scanf("%d%d",&n,&m); // n towns, m days
	for(i=1;i<=n;i++){
		// ordinary DSU preparing
		pr_cc[i]=i;size_cc[i]=1;
		pr_bcc[i]=i;size_bcc[i]=1;
		pr[i]=0;
	}
	SumCC=n,SumBCC=n; // sum of squares of connected components' sizes and sum of squares of biconnected components' sizes
	for(i=1;i<=m;i++){
		scanf("%d%d",&x,&y); // read an edge
		a=GetBCC(x); // x's BCC
		b=GetBCC(y); // y's BCC
		if(a==b){ // if x and y belong to the same BCC, nothing will be changed
			printf("%lld\n",(SumCC-SumBCC)/2); // output an answer
			continue;
		}
		cc_a=GetCC(x); // x's connected component
		cc_b=GetCC(y); // y's connected component
		if(cc_a!=cc_b){ // if x and y belong to the different connected components
			if(size_cc[cc_a]>size_cc[cc_b]){ // heuristics in order to obtain amortized O(N log N). we will make the vertice from the smallest subtree root
				swap(a,b);
				swap(cc_a,cc_b);
			}
			k=GetBCC(a);rt=k,chi=0; // make a (actually the BCC of x or the BCC of y) root
			while(k){
				p=GetBCC(pr[k]); // get the parent of k in the BCCs' tree
				// then, lift k:
				pr[k]=chi; 
				pr_cc[k]=rt;
				chi=k;
				k=p;
			}			
			// modify the sum of squares of the connected components' sizes:
			SumCC-=size_cc[cc_a]*1LL*size_cc[cc_a]; 
			SumCC-=size_cc[cc_b]*1LL*size_cc[cc_b];
			// merge two connected components:
			pr[a]=pr_cc[a]=b; 
			size_cc[cc_b]+=size_cc[cc_a];
			SumCC+=size_cc[cc_b]*1LL*size_cc[cc_b]; // and modify the sum of squares of the connected components' sizes again
		}else{ // otherwise if they belong to the same tree in the BCCs' forest
			++cu;ca[0]=cb[0]=lca=0;
			while(1){ // finding the LCA
				if(a){ // lift from a (x's BCC) in the tree
					a=GetBCC(a);
					ca[++ca[0]]=a; // write out all the nodes of the path
					if(u[a]==cu){ // if the LCA is found, remember it and quit
						lca=a;
						break;
					}
					u[a]=cu;
					a=pr[a];
				}
				if(b){ // lift from b (y's BCC) in the tree
					b=GetBCC(b);
					cb[++cb[0]]=b; // write out all the nodes of the path
					if(u[b]==cu){ // if the LCA is found, remember it and quit
						lca=b;
						break;
					}
					u[b]=cu;
					b=pr[b];
				}
			}
			SumBCC-=size_bcc[lca]*1LL*size_bcc[lca]; //modify the sum of BCCs' sizes squares
			for(j=1;j<=ca[0];j++){
				if(ca[j]==lca)break;
				pr_bcc[ca[j]]=lca; // shrink into a single vertice
				// modify the sum of squares of the biconnected components' sizes:
				size_bcc[lca]+=size_bcc[ca[j]]; 
				SumBCC-=size_bcc[ca[j]]*1LL*size_bcc[ca[j]];
			}
			for(j=1;j<=cb[0];j++){
				if(cb[j]==lca)break;
				pr_bcc[cb[j]]=lca; // shrink into a single vertice
				// modify the sum of squares of the biconnected components' sizes:				
				size_bcc[lca]+=size_bcc[cb[j]];
				SumBCC-=size_bcc[cb[j]]*1LL*size_bcc[cb[j]];
			}
			SumBCC+=size_bcc[lca]*1LL*size_bcc[lca]; // and modify the sum of squares of the biconnected components' sizes once again
		}
		printf("%lld\n",(SumCC-SumBCC)/2); // output an answer
	}
	return 0;
}
